<?php

class AlbumImageController extends RController {
    /**
     * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
     * using two-column layout. See 'protected/views/layouts/column2.php'.
     */
    // public $layout='//layouts/column2';

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'rights',
            'postOnly + delete', // we only allow deletion via POST request
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id) {
        $this->render('view', array(
            'model' => $this->loadModel($id),
        ));
    }

    public function actionUpload($album_id) {
        $album = Album::model()->findByPk($album_id);
        if ($album === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        $model = new AlbumImage;
        $model->album_id = $album_id;
        if (isset($_FILES['images']) && isset($_POST['AlbumImage'])) {

            $model->attributes = $_POST['AlbumImage'];
            $images = CUploadedFile::getInstancesByName('images');
            // proceed if the images have been set
            if (isset($images) && count($images) > 0) {
                $ok = true;
                // go through each uploaded image
                foreach ($images as $image => $pic) {
                    $extension = $pic->getExtensionName();
                    if (!in_array($extension, ['png', 'jpg', 'jpeg', 'gif', 'swf', 'flv'])) {
                        continue;
                    }
                    $picname = uniqid() . '.' . $extension;
                    $saveDir = Yii::app()->params['uploadDir'] . get_class($model);
                    $path = $saveDir . '/' . $picname;
                    if ($pic->saveAs($path)) {
                        $imageObj = Yii::app()->image->load($path);
                        $new_height = 96;
                        $new_width = round(($imageObj->width * $new_height) / $imageObj->height);
                        $imageObj->resize($new_width, $new_height, Image::NONE);
                        $imageObj->save($saveDir . '/thumbs/' . $picname);


                        // add it to the main model now
                        $image = new AlbumImage();
                        $image->image = $picname; //it might be $image->name for you, filename is just what I chose to call it in my model
                        $image->album_id = $album_id; // this links your picture model to the main model (like your user, or profile model)
                        if ($image->save()) {
                            $ok = $ok && true;
                        } else {
                            echo 'ERROR!';
                            echo '<pre dir="ltr">', var_dump($image->getErrors()), '</pre>';
                        }
                    } else {
                        echo 'Cannot upload!';
                    }
                }
                if ($ok) {
                    $this->redirect(array('albumImage/admin', 'album_id' => $album_id));
                }
            }
        }
        $this->render('upload', array(
            'model' => $model,
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate($album_id) {
        $model = new AlbumImage;
        $model->album_id = $album_id;

        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);

        if (isset($_POST['AlbumImage'])) {
            $model->attributes = $_POST['AlbumImage'];
            if ($model->save()) {
                Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully created.'));
                $this->redirect(array('admin'));
            }
        }

        $this->render('create', array(
            'model' => $model,
        ));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id) {
        $model = $this->loadModel($id);

        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);

        if (isset($_POST['AlbumImage'])) {
            $model->attributes = $_POST['AlbumImage'];
            if ($model->save()) {
                Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully updated.'));
                $this->redirect(array('admin'));
            }
        }

        $this->render('update', array(
            'model' => $model,
        ));
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id) {
        $this->loadModel($id)->delete();

        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if (!isset($_GET['ajax'])) {
            Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully deleted.'));
            $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        }
    }

    /**
     * Lists all models.
     */
    public function actionIndex() {
        $dataProvider = new CActiveDataProvider('AlbumImage');
        $this->render('index', array(
            'dataProvider' => $dataProvider,
        ));
    }

    /**
     * Manages all models.
     */
    public function actionAdmin($album_id) {
        $model = new AlbumImage('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['AlbumImage'])) {
            $model->attributes = $_GET['AlbumImage'];
        }
        $model->album_id = $album_id;

        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return AlbumImage the loaded model
     * @throws CHttpException
     */
    public function loadModel($id) {
        $model = AlbumImage::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param AlbumImage $model the model to be validated
     */
    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'album-image-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

}
